#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "zap0010one4xi.py">
#<abstract4xi abstract = "zaps to direction one"/>
#<verify4xi verification = "11" target = "zap2actor4xi.py"/>
#<refer4xi reference = "zap2actor4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'zap0010one4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import itertools
import logging 
import os
import threading                
import signal
import sys
from math import pi
from math import sin
from math import cos 
from math import fabs
import weakref
import _thread
import _winapi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from zap2module4xi import ModuleKB2Zap4Xi
from print4xi      import print4xi
from time4xi       import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
# do NO define any globals for this kind of multiprocessing/thread module !!
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
ack2dragontrace = False 
#" 
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "zap0010one4xi" usage = "target function for zap0000one4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def zap0010one4xi(queue0010one, consumer_channel0010one, publisher_channel0010one, kb0010one):  
    '''
    returns layer 0010 of direction one
    ''' 
    # -------------------------------------------------------------------------------------------------
    # (Step 1/33)             
    # -------------------------------------------------------------------------------------------------   
    class2print  = 'zap0010one4xi'
    method2print = 'zap0010one4xi'
        
    # -------------------------------------------------------------------------------------------------
    # (Step 2/33)                      
    # -------------------------------------------------------------------------------------------------                                                               
    if ack2debug is True:
        print("\n (Step 2A/33) OF ZAP0010ONE4XI - STARTED TIME: ", time4xi())                                      # 
        print("\n (Step 2B/33) OF ZAP0010ONE4XI -  QUEUE0010ONE: ", queue0010one)                                  # 
        print("\n (Step 2C/33) OF ZAP0010ONE4XI -  CONSUME_CHANNEL0010ONE: ", consumer_channel0010one)             # 
        print("\n (Step 2D/33) OF ZAP0010ONE4XI -  PUBLISHER_CHANNEL0010ONE: ", publisher_channel0010one)          # 
        print("\n (Step 2E/33) OF ZAP0010ONE4XI -  KB2ONE: ", kb0010one)                                              
        # {  '1x1y1z': {'2xi': {1: 1, 2: 2, 3: {1: 6.283185307179586, 2: '#848484', 3: 1, 4: 6.283185307179586}, 4: 'dragon1x1y1z', 5: '#6F4A20', 6: 1, 7: 33, 8: 1.7325080757, 9: 0.267949192431, 10: 8, 11: '{started; sense-of-1Skeleton4Xi-started: 01:34:04 12/14/10 Pacific Standard Time}', 12: 'sense', 13: 2}, '8xi': {}, '4xi': {}}, 
        #   '0x0y39z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y39z', 5: '#9BA2A2', 6: 69, 7: 1, 8: Decimal('39.0'), 9: Decimal('29'), 10: 1, 11: '{passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1}, '8xi': {}, '4xi': {}}, 
        #   '0x0y59z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y59z', 5: '#9BA2A2', 6: 70, 7: 1, 8: Decimal('59.0'), 9: Decimal('49'), 10: 1, 11: "{returning; kb4xi-returning-by-reason-object4xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason_object4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #   '0x0y19z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y19z', 5: '#9BA2A2', 6: 68, 7: 1, 8: Decimal('19.0'), 9: Decimal('9'), 10: 1, 11: '{started; reason-object4xi-started: function reason_object4xi at 0x02A5F660; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1}, '8xi': {}, '4xi': {}}, 
        # '0x0y3199z': {'2xi': {1: 1, 2: 3200, 3: {1: 16084954.386379741, 2: '#848484', 3: 4, 4: 4021238.5965949353}, 4: 'dragon0x0y3199z', 5: '#7C6142', 6: 3201, 7: 1, 8: 3200, 9: 0, 10: 1, 11: '{started; sense-of-Cluster4Xi-started: 01:34:04 12/14/10 Pacific Standard Time}', 12: 'cluster', 13: 1}, '8xi': {}, '4xi': {}}, 
        # '0x0y3299z': {'2xi': {1: 1, 2: 3300, 3: {1: 17105971.998796422, 2: '#848484', 3: 4, 4: 4276492.9996991055}, 4: 'dragon0x0y3299z', 5: '#9BA2A2', 6: 3302, 7: 1, 8: 3300, 9: 0, 10: 1, 11: '{started; sense-of-Cluster4Xi-started: 01:34:05 12/14/10 Pacific Standard Time}', 12: 'cluster', 13: 1}, '8xi': {}, '4xi': {}}}
         
        
        
    if ack2dragontrace is True:
        message2print = "{(Step 2A/33) started" + "; zap0010one4xi-started: " + str(zap0010one4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              # zap0010one4xi-started: <function zap0010one4xi at 0x0443D030>
        
        message2print = "{(Step 2B/33) passed" + "; queue0010one-passed-to-zap0010one4xi: " + str(queue0010one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              # <queue4xi.Queue4Xi object at 0x0532A8B0>  
                      
        message2print = "{(Step 2C/33) passed" + "; consumer-channel0010one-passed-to-zap0010one4xi: " + str(consumer_channel0010one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              # <read-write PipeConnection, handle 224>        
        
        message2print = "{(Step 2D/33) passed" + "; publisher-channel0010one-passed-to-zap0010one4xi: " + str(publisher_channel0010one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              # <read-write PipeConnection, handle 220>            
        
        message2print = "{(Step 2E/33) passed" + "; kb0010one-passed-to-zap0010one4xi: " + str(kb0010one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              #         
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/33)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ack2debug is True:
        print("\n (Step 3/33) OF ZAP0010ONE4XI - TRYING TO PUT LAYER 0010 TO QUEUE0010ONE: ", queue0010one)         # <queue4xi.Queue4Xi object at 0x0532A8B0>
    if ack2dragontrace is True:
        message2print = "{(Step 3/33) using" + "; queue0010one-using-by-zap0010one4xi: " + str(queue0010one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              # <queue4xi.Queue4Xi object at 0x0532A8B0>    
            
    ack0010put4one = False                                                                                                                           

    # ------------------------------------------------------------------------------------- 
    # (Step 4/33) 
    # -------------------------------------------------------------------------------------                 

    # ------------------------------------------------------------------------------------- 
    # CONSTANTS VALID FOR ANY ZAP-KOWLEDGEBASE  
    # -------------------------------------------------------------------------------------     
    key2sense       = '2xi'
    key2reason      = '4xi'
    key2ace         = '8xi'
    key2direction   = 1
    key2distance    = 2
    key2layer       = 3
    
    key2area4layer  = 1
    key2color4layer = 2
    key2qty4layer   = 3
    key2area4node   = 4
    
    key2identity    = 4 
    key2color       = 5
    key2fire        = 6
    key2cluster     = 7
    key2ray         = 8
    key2deviation   = 9 
    key2super       = 10
    key2message     = 11
    key2actor       = 12
    key2type        = 13
    key2home        = 14
    key2previous    = 15
    key2next        = 16
    key2last        = 17
    key2first       = 18
    key2module      = 19
      
    # ------------------------------------------------------------------------------------- 
    # (Step 5/33) CONSTANTS VALID FOR LAYER 0010 OF DIRECTION ONE 
    # ------------------------------------------------------------------------------------- 
    direction0010sense4one = 1                                                                                                      # DIRECTION
    if ack2dragontrace is True:
        message2print = "{(Step 5A/33) set" + "; direction0010sense4one-set-by-zap0010one4xi to: " + str(direction0010sense4one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                              # 1  
            
    distance0010sense4one  = 10                                                                                                     # DISTANCE = LAYER
    if ack2dragontrace is True:
        message2print = "{(Step 5B/33) set" + "; distance0010sense4one-set-by-zap0010one4xi to: " + str(distance0010sense4one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                              # 10  
                                                                 
    # ------------------------------------------------------------------------------------- 
    # (Step 6/33) CREATE NEW KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------         
    keys0010one = kb0010one.keys()
    kb0010one2put = {}
    for key0010one in keys0010one:
        if ((kb0010one[key0010one] [key2sense] [key2distance] == distance0010sense4one) and (kb0010one[key0010one] [key2sense] [key2direction] == direction0010sense4one)):
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------        
            if ack2debug is True:
                print("\n (Step 6A0/33) OF ZAP0010ONE4XI - LEVEL NODE'S KEY: ", key0010one, " CONTENT: ", kb0010one[key0010one])
            #  
            if ack2dragontrace is True:
                message2print = "{(Step 6A0/33) set" + "; nodekey-set-by-zap0010one4xi to: " + str(key0010one)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                      # 0x0y39z            
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------         
            try:                                                                                                                    
                kb0010one2put [key0010one] = {}                                                                                     # SAVE THE LAYER OF THE REQUIRED DIRECTION
            except:
                print("\n (Step 6A/33) OF ZAP0010ONE4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010ONE: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            try:         
                kb0010one2put [key0010one] [key2sense]  = {}                                                                        # SENSE
            except:
                print("\n (Step 6B/33) OF ZAP0010ONE4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010ONE: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                   
            if ack2debug is True:
                print("\n (Step 6C/33) OF ZAP0010ONE4XI - TRYING TO SET DIRECTION AT: ", kb0010one [key0010one] [key2sense] )     # 1  
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2direction] = kb0010one [key0010one] [key2sense] [key2direction]         # DIRECTION 
                if ack2dragontrace is True:
                    message2print = "{(Step 6D/33) set" + "; direction-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2direction])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 1 
                         
            except:
                print("\n (Step 6E/33) OF ZAP0010ONE4XI *** FAILED TO SET DIRECTION AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6F/33) OF ZAP0010ONE4XI - TRYING TO SET DISTANCE AT: ", kb0010one [key0010one] [key2sense] )      # 10                 
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2distance] = kb0010one [key0010one][key2sense] [key2distance]           # DISTANCE
                if ack2dragontrace is True:
                    message2print = "{(Step 6G/33) set" + "; distance-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2distance])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                             # 10 
            except:
                print("\n (Step 6B4B/33) OF ZAP0010ONE4XI *** FAILED TO SET DISTANCE AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B5A/33) OF ZAP0010ONE4XI - TRYING TO SET LAYER AT: ", kb0010one [key0010one] [key2sense] )       # {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}               
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2layer] = {}                                                            # LAYER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B5B/33) set" + "; layer-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                             # {}                 
            except:
                print("\n (Step 6B5Z/33) OF ZAP0010ONE4XI *** FAILED TO SET LAYER AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B6A/33) OF ZAP0010ONE4XI - TRYING TO SET AREA FOR LAYER AT: ", kb0010one [key0010one]  [key2sense] [key2layer] )                   
            try:                                                                                                                    # 157.079632679                      
                kb0010one2put [key0010one] [key2sense] [key2layer] [key2area4layer] = kb0010one [key0010one] [key2sense] [key2layer] [key2area4layer] 
                                                                                                                                    # AREA2LAYER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B6B/33) set" + "; area2layer-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2layer] [key2area4layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 157.079632679                  
            except:
                print("\n (Step 6B6Z/33) OF ZAP0010ONE4XI *** FAILED TO SET AREA FOR LAYER AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B7A/33) OF ZAP0010ONE4XI - TRYING TO SET COLOR FOR LAYER AT: ", kb0010one [key0010one]  [key2sense] [key2layer]  )
                                                                                                                                    # #848484                     
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2layer] [key2color4layer] = kb0010one [key0010one] [key2sense] [key2layer] [key2color4layer]
                                                                                                                                    # COLOR2LAYER 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B7B/33) set" + "; color2layer-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2layer] [key2color4layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # #848484                 
            except:
                print("\n (Step 6B7Z/33) OF ZAP0010ONE4XI *** FAILED TO SET COLOR FOR LAYER AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B8A/33) OF ZAP0010ONE4XI - TRYING TO SET QUANTITY FOR LAYER: ", kb0010one [key0010one]  [key2sense] [key2layer]  )
                                                                                                                                    # 3                          
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2layer] [key2qty4layer] = kb0010one [key0010one] [key2sense] [key2layer] [key2qty4layer]
                                                                                                                                    # QTY2LAYER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B8B/33) set" + "; qty2layer-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2layer] [key2qty4layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 3                  
            except:
                print("\n (Step 6B8Z/33) OF ZAP0010ONE4XI *** FAILED TO SET QUANTITY FOR LAYER AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B9A/33) OF ZAP0010ONE4XI - TRYING TO SET AREA FOR NODE: ", kb0010one  [key0010one] [key2sense] [key2layer]  )
                                                                                                                                    # 52.3598775598                          
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2layer] [key2area4node] = kb0010one [key0010one] [key2sense] [key2layer] [key2area4node]
                                                                                                                                    # AREA2NODE
                if ack2dragontrace is True:
                    message2print = "{(Step 6B9B/33) set" + "; area2node-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2layer] [key2area4node])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # 52.3598775598               
            except:
                print("\n (Step 6B9Z/33) OF ZAP0010ONE4XI *** FAILED TO SET AREA FOR NODE AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B10A/33) OF ZAP0010ONE4XI - TRYING TO SET IDENTITY: ", kb0010one  [key0010one] [key2sense] )   # dragon0x0y39z                
            try:                              
                kb0010one2put [key0010one] [key2sense] [key2identity] = kb0010one[ key0010one] [key2sense] [key2identity]           # IDENTITY
                if ack2dragontrace is True:
                    message2print = "{(Step 6B10B/33) set" + "; identity-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2identity])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # dragon0x0y39z                  
            except:
                print("\n (Step 6B10Z/33) OF ZAP0010ONE4XI *** FAILED TO SET IDENTITY AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B11A/33) OF ZAP0010ONE4XI - TRYING TO SET COLOR: ", kb0010one [key0010one]  [key2sense] )      # #9BA2A2                  
            try:                              
                kb0010one2put [key0010one] [key2sense] [key2color] = kb0010one [key0010one]  [key2sense] [key2color]                # COLOR
                if ack2dragontrace is True:
                    message2print = "{(Step 6B11B/33) set" + "; color-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2color])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # #9BA2A2                  
            except:
                print("\n (Step 6B11Z/33) OF ZAP0010ONE4XI *** FAILED TO SET COLOR AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B12A/33) OF ZAP0010ONE4XI - TRYING TO SET FIRE: ", kb0010one [key0010one]  [key2sense] )       # 69 
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2fire] = kb0010one [key0010one]  [key2sense] [key2fire]                  # FIRE 
                if ack2dragontrace is True:
                    message2print = "{STEP 2B12A/33) set" + "; fire-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2fire])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # 69  
                        
            except:
                print("\n (Step 6B12Z/33) OF ZAP0010ONE4XI *** FAILED TO SET FIRE AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B13A/33) OF ZAP0010ONE4XI - TRYING TO SET CLUSTER: ", kb0010one [key0010one]  [key2sense] )    # 1
                                  
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2cluster] = kb0010one [key0010one]  [key2sense] [key2cluster]            # CLUSTER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B13B/33) set" + "; cluster-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2cluster])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 1                   
            except:
                print("\n (Step 6B13Z/33) OF ZAP0010ONE4XI *** FAILED TO SET CLUSTER AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B14A/33) OF ZAP0010ONE4XI - TRYING TO SET RAY: ", kb0010one [key0010one]  [key2sense] )        # 39.0               
            try:                             
                kb0010one2put[key0010one] [key2sense] [key2ray] = kb0010one [key0010one]  [key2sense] [key2ray]                     # RAY 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B14B/33) set" + "; ray-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put[key0010one] [key2sense] [key2ray])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # 39.0                 
            except:
                print("\n (Step 6B14Z/33) OF ZAP0010ONE4XI *** FAILED TO SET RAY AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B15A/33) OF ZAP0010ONE4XI - TRYING TO SET DEVIATION: ", kb0010one [key0010one]  [key2sense] )  # 29                  
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2deviation] = kb0010one [key0010one]  [key2sense] [key2deviation]        # DEVIATION
                if ack2dragontrace is True:
                    message2print = "{(Step 6B15B/33) set" + "; deviation-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2deviation])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # 29                 
            except:
                print("\n (Step 6B15Z/33) OF ZAP0010ONE4XI *** FAILED TO SET DEVIATION AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B16A/33) OF ZAP0010ONE4XI - TRYING TO SET SUPER: ", kb0010one [key0010one]  [key2sense] [key2super])     # 1                  
            try:                              
                kb0010one2put[key0010one] [key2sense] [key2super] = kb0010one [key0010one]  [key2sense] [key2super]                 # SUPER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B16B/33) set" + "; super-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put[key0010one] [key2sense] [key2super])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # 1                  
            except:
                print("\n (Step 6B16Z/33) OF ZAP0010ONE4XI *** FAILED TO SET SUPER AT LAYER 0010 TO QUEUE0010ONE: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B17A/33) OF ZAP0010ONE4XI - TRYING TO SET MESSAGE: ", kb0010one [key0010one]  [key2sense] )    # {passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}               
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2message] = kb0010one [key0010one]  [key2sense] [key2message]            # MESSAGE
                if ack2dragontrace is True:
                    message2print = "{(Step 6B17B/33) set" + "; message-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # {passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}
                                 
            except:
                print("\n (Step 6B17C/33) OF ZAP0010ONE4XI - TRYING TO GENERATE DUMMY MESSAGE TO: ", kb0010one [key0010one]  [key2sense])     
                try:
                                                                                                                                    # set default message
                    kb0010one2put [key0010one] [key2sense] [key2message] = "{(Step 6B17C/33) yielded" + "; key2message-yielded-by-zap0010one4xi: " + str(key2message)  + "; time: " + time4xi() + "}"
                    
                    message2print = "{(Step 6B17D/33) set" + "; message-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #
                except:    
                    print("\n (Step 6B17Z/33) OF ZAP0010ONE4XI *** FAILED TO SET MESSAGE AT LAYER 0010: ", key0010one) 
                                        
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B18A/33) OF ZAP0010ONE4XI - TRYING TO SET ACTOR: ", kb0010one [key0010one]  [key2sense] )      # reason_object4xi                    
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2actor] = kb0010one [key0010one]  [key2sense] [key2actor]                # ACTOR 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B18B/33) set" + "; actor-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # reason_object4xi                 
            except:
                try:
                    kb0010one2put [key0010one] [key2sense] [key2actor] = 'zap0010one4xi'                                            # THIS BECOMES THE ACTOR!
                    message2print = "{(Step 6B18C/33) set" + "; actor-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                except:                            
                    print("\n (Step 6B18Z/33) OF ZAP0010ONE4XI *** FAILED TO SET ACTOR AT LAYER 0010: ", key0010one)
                    # 
          
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B19A/33) OF ZAP0010ONE4XI - TRYING TO SET TYPE: ", kb0010one [key0010one]  [key2sense] )       # 1                 
            try:                             
                kb0010one2put [key0010one] [key2sense] [key2type] = kb0010one [key0010one]  [key2sense] [key2type]                  # TYPE 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B19B/33) set" + "; type-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # 1                 
            except:
                try:
                    kb0010one2put [key0010one] [key2sense] [key2type] = 1                                                           # THIS IS function
                    message2print = "{(Step 6B19C/33) set" + "; type-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              #                
                except:
                    print("\n (Step 6B19Z/33) OF ZAP0010ONE4XI *** FAILED TO SET TYPE AT LAYER 0010: ", key0010one)
                    # 
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B20A/33) OF ZAP0010ONE4XI - TRYING TO SET REASON: ", kb0010one [key0010one]  )                 # {}                     
            try:                              
                kb0010one2put [key0010one] [key2reason] = kb0010one [key0010one] [key2reason]                                       # REASON
                if ack2dragontrace is True:
                    message2print = "{(Step 6B20B/33) set" + "; reason-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2reason])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # {}                  
            except:
                print("\n (Step 6B20Z/33) OF ZAP0010ONE4XI *** FAILED TO SET REASON AT LAYER 0010: ", key0010one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B21A/33) OF ZAP0010ONE4XI - TRYING TO SET ACE: ", kb0010one [key0010one]   )                   # {}                  
            try:                             
                kb0010one2put [key0010one] [key2ace]    = kb0010one [key0010one] [key2ace]                                          # ACE
                if ack2dragontrace is True:
                    message2print = "{(Step 6B21B/33) set" + "; ace-of-zap-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2ace])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # {}                  
            except:
                print("\n (Step 6B21Z/33) OF ZAP0010ONE4XI *** FAILED TO SET ACE AT LAYER 0010: ", key0010one)
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B22A/33) OF ZAP0010ONE4XI - TRYING TO SET MODULE: ", kb0010one [key0010one]  [key2sense] [key2actor])     # reason_object4xi                    
                                                                                              
            try:
                key2try = kb0010one [key0010one]  [key2sense] [key2actor]
                if ack2debug is True:
                    print("\n (Step 6B22B/33) OF ZAP0010ONE4XI - KEY2TRY: ", key2try) 
                    
                kb0010one2put [key0010one] [key2sense] [key2module] = ModuleKB2Zap4Xi[key2try]                                   
                
                if ack2dragontrace is True:
                    message2print = "{(Step 6B22C/33) set" + "; module-set-by-zap0010one4xi to: " + str(kb0010one2put [key0010one] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # reason_object4xi.py

            except:
                try:
                    kb0010one2put [key0010one] [key2sense] [key2module] = 'zap0010one4xi.py'                                        # THIS BECOMES THE MODULE IN EXCEPTIONS
                    print("\n (Step 6B22Z1/33) OF ZAP0010ONE4XI ** YIELDED - SET MODULE TO: ", kb0010one2put [key0010one] [key2sense] [key2module])
                    message2print = "{(Step 6B22Z1/33) yielded" + "; module-yielded-by-zap2actor4xi: " + str(kb0010one2put [key0010one] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                          
                except:    
                    print("\n (Step 6B22Z2/33) OF ZAP0010ONE4XI *** FAILED TO SET MODULE AT LAYER 0010: ", key0010one)              #
                    #                                                                                       
 
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
        else:
            pass
            
    # -------------------------------------------------------------------------------------------------
    # (Step 7/33) BUILD LINK LIST AT LAYER 0010 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:
        print("\n (Step 7A/33) OF ZAP0010ONE4XI - TRYING TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION ONE FROM : ", kb0010one2put)
                                                                                                                                    # '0x0y19z': {'2xi': {6: 68 ...
                                                                                                                                    # '0x0y59z': {'2xi': {6: 70 ...
                                                                                                                                    # '0x0y39z': {'2xi': {6: 69 ...

    try:                             
        keys0010one2put = kb0010one2put.keys()                                                                                      # 68,69,70 
        kb0010link4one = {} 
        order2link = 1
        for key0010one2put in keys0010one2put:
            key0010navigation4one = kb0010one2put [key0010one2put] [key2sense] [key2fire]                                           # input nodes embed fire number 
            kb0010link4one [order2link] = {}
            kb0010link4one [order2link] [key0010one2put] = {}
            kb0010link4one [order2link] [key0010one2put] [1]    = 0                                                                 # order                                                                                                                                 
            kb0010link4one [order2link] [key0010one2put] [2]    = '0x0y0z'                                                          # home                                                           
            kb0010link4one [order2link] [key0010one2put] [3]    = '0x0y0z'                                                          # previous
            kb0010link4one [order2link] [key0010one2put] [4]    = '0x0y0z'                                                          # next
            kb0010link4one [order2link] [key0010one2put] [5]    = '0x0y0z'                                                          # last
            kb0010link4one [order2link] [key0010one2put] [6]    = '0x0y0z'                                                          # first
            kb0010link4one [order2link] [key0010one2put] [7]    = 0                                                                 # fire number
            order2link = order2link + 1
            
        keys0010link4one = kb0010link4one.keys()                                                                                    # keys of input knowledgebase
        if ack2debug is True:
            for key0010link4one in sorted(keys0010link4one):                                                                        # keys of linklist
                if ack2debug is True:
                    print("\n (Step 7B/33) OF ZAP0010ONE4XI KB0010LINK4ONE[", key0010link4one, "]: ", kb0010link4one[key0010link4one])  # [ 1 ]:  {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7:0}}
                                                                                                                                    # [ 2 ]:  {'0x0y59z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7:0}}
                                                                                                                                    # [ 3 ]:  {'0x0y39z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7:0}}
    except:
        print("\n (Step 7D/33) OF ZAP0010ONE4XI *** FAILED TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION ONE: ", kb0010link4one) 
        if ack2dragontrace is True:
            message2print = "{(Step 7E/33) failed" + "; kb0010link4one-failed-by-zap0010one4xi: " + str(kb0010link4one) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        
    # -------------------------------------------------------------------------------------------------
    # (Step 8A/33) BUILD FIRE LIST
    # -------------------------------------------------------------------------------------------------                       
    if ack2debug is True:
        print("\n (Step 8A1/33) OF ZAP0010ONE4XI - TRYING BUILD FIRE KNOWLEDGEBASE")
    try:
        kb0010fire4one = {}
        keys0010one2put = kb0010one2put.keys()                                                                                      # '0x0y19z', '0x0y59z', '0x0y39z'              
        for key0010one2put in keys0010one2put:
            key0010fire4one = kb0010one2put [key0010one2put] [key2sense] [key2fire]                                                 #    68,      70,        69
            kb0010fire4one[key0010fire4one] = key0010one2put                                                                        # '0x0y19z','0x0y59z', '0x0y39z'
        if ack2debug is True:
            print("\n (Step 8A2/33) OF ZAP0010ONE4XI - BUILT FIRE KNOWLEDGEBASE: ", kb0010fire4one)                                 # {68: '0x0y19z', 69: '0x0y39z', 70: '0x0y59z'}           
    except:
        print("\n (Step 8A3/33) OF ZAP0010ONE4XI *** FAILED BUILD FIRE KNOWLEDGEBASE")
        if ack2dragontrace is True:
            message2print = "{(Step 8Z/33) failed" + "; kb0010fire4one-failed-by-zap0010one4xi: " + str(kb0010fire4one) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
       
    # -----------------------------------------------------------------------------------------------------------------------------
    # (Step 8C/33) EMBED FIRES TO LINK LIST  
    # -----------------------------------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8C1/33) OF ZAP0010ONE4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION ONE")     

    keys2fire = kb0010fire4one.keys()
    rank2xi = 1
    for key2fire in sorted(keys2fire):                                                                                              # 68,69,70                                                                        
        # -------------------------------------------------------------------------------------------------------------------------
        # 
        # -------------------------------------------------------------------------------------------------------------------------                                                                                     
        if ack2debug is True:
            print("\n (Step 8C5/33) OF ZAP0010ONE4XI - KEY2FIRE: ", key2fire)                                                       # 68,69,70 

        coordinate2rank = kb0010fire4one[key2fire]                                                                                  # '0x0y19z' is the first one                                                                    
        
        
        keys2link = kb0010link4one.keys()                                                                                           
        for keylink in keys2link:                                                                                                   # 1,2,3
            try:
                if kb0010link4one [keylink] [coordinate2rank]  [7] == 0:            
                    kb0010link4one [keylink] [coordinate2rank] [7] = key2fire                                                       # 68
                if kb0010link4one [keylink] [coordinate2rank]  [1] == 0:
                    kb0010link4one [keylink] [coordinate2rank] [1] = rank2xi                                                        # 1 = the first one 
                    rank2xi = rank2xi + 1
                if ack2debug is True:    
                    print("\n (Step 8D10/33) OF ZAP0010ONE4XI - MATCH: UPDATED KB0010LINK4ONE: ", kb0010link4one)                   # KB0010LINK4ONE[ 1 ]:  {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}
                                                                                                                                    # KB0010LINK4ONE[ 2 ]:  {'0x0y59z': {1: 3, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 70}}
                                                                                                                                    # KB0010LINK4ONE[ 3 ]:  {'0x0y39z': {1: 2, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 69}}
            except:
                pass               

    
    # ---------------------------------------------------------------------------------------------------------------------
    # (Step 8D/33) PRINT LINKING LIST WITH ONE FIRE EMBEDDED  
    # ---------------------------------------------------------------------------------------------------------------------                    
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0010ONE4XI - TRYING TO PRINT LINKING LIST WITH ONE FIRE EMBEDDED ")   
        try: 
            print("\n (Step 8C7/33) OF ZAP0010ONE4XI - KB0010LINK4ONE: ", kb0010link4one)                                           # 
        except:                                                                                                                         
            print("\n (Step 8Z4/33) OF ZAP0010ONE4XI *** FAILED TO PRINT LINKING LIST WITH ONE FIRE EMBEDDED") 
                        
            
    # -------------------------------------------------------------------------------------------------
    # (Step 8E/33) EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION ONE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0010ONE4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")      
                                                                                                                           
    keys0010one2put = kb0010one2put.keys()
                                               
    # -------------------------------------------------------------------------------------------------
    # THE LATEST VALUES TO BE CHANGED DURING WALKTROUGHS
    # -------------------------------------------------------------------------------------------------     
    origin2link         = '0x0y0z'                                                                                                  # link to origin
    home2link           = '-0x-0y-0z'                                                                                               # unresolved-home  
    previous2link       = '-0x-0y-0z'                                                                                               # unresolved-previous 
    next2link           = '+0x+0y+0z'                                                                                               # unresolved-next 
    first2link          = '+0x+0y+0z'                                                                                               # unresolved-first 
    last2link           = '+0x+0y+0z'                                                                                               # unresolved-last 
    max2last            = 0                                                                                                         # maximun order number for the last node - default 0

                                                                                                             
    # -------------------------------------------------------------------------------------------------
    # (Step 8E1/33) THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8E1a/33) OF ZAP0010ONE4XI - TRYING THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")               
    for key0010one2put in keys0010one2put:
        # -------------------------------------------------------------------------------------------------
        # KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION ONE
        # -------------------------------------------------------------------------------------------------                                                                                      
        if ack2debug is True:
            print("\n (Step 8E1b/33) OF ZAP0010ONE4XI KB0010LINK4ONE - KEY0010ONE2PUT: ", key0010one2put)                           # 1. '0x0y19z'; 2. '0x0y59z'; 3. '0x0y39z'  
        keys2link = kb0010link4one.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 8E1c/33) OF ZAP0010ONE4XI KB0010LINK4ONE - KEY2LINK: ", key2link)                                   # 1.; 2.
            # ---------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4one[key2link]
                keys2check = kb2check.keys()
                for key2check in keys2check:
                    # ---------------------------------------------------------------------------------------------
                    # NODE(S) OF LINK LIST AT LAYER 0010 OF DIRECTION ONE
                    # -------------------------------------------------------------------------------------------                   
                    if key2check == key0010one2put: 
                        if ack2debug is True:
                            print("\n (Step 8E1d/33) OF ZAP0010ONE4XI KB0010LINK4ONE - MATCH WITH KEY0010ONE2PUT: ", key0010one2put)    # 1. 0x0y19z; 2. 0x0y59z; 3. 0x0y39z                                                                         
                        if kb0010link4one[key2link] [key0010one2put] [1] == 1:                                                          # the first none in fire order at this layer to required direction
                            if ack2debug is True:
                                print("\n (Step 8E1e/33) OF ZAP0010ONE4XI KB0010LINK4ONE - THE FIRT NODE: ", key0010one2put)            # THE FIRT NODE:  0x0y19z
                                  
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                                              
                            first2link        = key0010one2put                                                                          # first-link points to this node                        
                            if ack2debug is True:
                                print("\n (Step 8E1f/33) OF ZAP0010ONE4XI KB0010LINK4ONE - SET FIRST2LINK TO: ", first2link)            
                                
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0010one2put [key0010one2put] [key2sense] [key2home]     = home2link                                       # 1. '0x0y0z'
                                                                     
                                                     
                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER THE FIRST NODE
                            # --------------------------------------------------------------------------------- 
                            if kb0010link4one[key2link] [key0010one2put] [1] > max2last:
                                last2link    = key0010one2put                                                                           # 1. '0x0y19z'
                                max2last     = kb0010link4one[key2link] [key0010one2put] [1]                                            # 1. becomes max
                        else:
                            if ack2debug is True:
                                print("\n (Step 8E1g/33) OF ZAP0010ONE4XI KB0010LINK4ONE - THE ", kb0010link4one[key2link] [key0010one2put] [1], ". NODE: ", key0010one2put)
                                                                                                                                        # THE  3 . NODE:  0x0y59z
                                                                                                                                        # THE  2 . NODE:  0x0y39z           
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------
                                                                                                                                        # none can be set in this pass!
                            
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0010one2put [key0010one2put] [key2sense] [key2home]     = home2link                                       # only link to be updated for output!

                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER TYPICAL NODE 
                            # --------------------------------------------------------------------------------- 
                            if kb0010link4one[key2link] [key0010one2put] [1] > max2last:
                                last2link    = key0010one2put                                                                           # 1. '0x0y19z'
                                max2last     = kb0010link4one[key2link] [key0010one2put] [1]                                            # 1. 1                       
                                                      
                           
                    else:
                        if ack2debug is True:
                            print("\n (Step 8E1h/33) OF ZAP0010ONE4XI KEY0010ONE2PUT - PASSED KEY2LINK: ", key2link, " WITH NODE: ", key0010one2put)              
            except:
                pass                                                                                                                    # nodes with different links
    # -------------------------------------------------------------------------------------------------
    # 
    # -------------------------------------------------------------------------------------------------                                  
    if ack2debug is True:
        # key2home        = 14 [OK]
        print("\n (Step 8E1i/33) OF ZAP0010ONE4XI - LATEST FIRST: ", first2link)                                                        # 0x0y19z  
        print("\n (Step 8E1j/33) OF ZAP0010ONE4XI - LATEST LAST: ", last2link)                                                          # 0x0y59z                               
        print("\n (Step 8E1k/33) OF ZAP0010ONE4XI - LATEST MAX ORDER: ",max2last)                                                       # 3              
                
    # -------------------------------------------------------------------------------------------------
    # (Step 9/33) THE SECOND WALKTROUGH TO EMBED THE FIRST AND LAST LINK TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 9A/33) OF ZAP0010ONE4XI - TRYING TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
    try:      
        for key0010one2put in keys0010one2put:
            # ---------------------------------------------------------------------------------------------
            # KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------    
            kb0010one2put [key0010one2put] [key2sense] [key2first] = first2link
            kb0010one2put [key0010one2put] [key2sense] [key2last]  = last2link
        # ------------------------------------------------------------------------------------------------- 
        #
        # -------------------------------------------------------------------------------------------------             
        if ack2debug is True:    
            print("\n (Step 9B/33) OF ZAP0010ONE4XI - UPDATED THE FIRST AND LAST LINK TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
            print("\n (Step 9C/33) OF ZAP0010ONE4XI - KB0010ONE2PUT: ", kb0010one2put)
            # key2last        = 17 [OK]
            # key2first       = 18 [OK]
            # {'0x0y19z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y19z', 5: '#9BA2A2', 6: 68, 7: 1, 8: Decimal('19.0'), 9: Decimal('9'), 10: 1, 11: '{started; reason-object4xi-started: function reason_object4xi at 0x02A5F660; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y59z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y59z', 5: '#9BA2A2', 6: 70, 7: 1, 8: Decimal('59.0'), 9: Decimal('49'), 10: 1, 11: "{returning; kb4xi-returning-by-reason-object4xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y39z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y39z', 5: '#9BA2A2', 6: 69, 7: 1, 8: Decimal('39.0'), 9: Decimal('29'), 10: 1, 11: '{passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}}
 
    except:        
        print("\n (Step 9Z/33) OF ZAP0010ONE4XI *** FAILED TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
        if ack2dragontrace is True:
            message2print = "{(Step 9Z/33) failed" + "; kb0010one2put-failed-by-zap0010one4xi: " + str(kb0010one2put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                  
    # -------------------------------------------------------------------------------------------------
    # (Step 10/33) THE THIRD WALKTROUGH TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 10A/33) OF ZAP0010ONE4XI - TRYING TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
    try:    
        # KB0010LINK4ONE[ 1 ]:  {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}
        # KB0010LINK4ONE[ 2 ]:  {'0x0y59z': {1: 3, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 70}}
        # KB0010LINK4ONE[ 3 ]:  {'0x0y39z': {1: 2, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 69}}
        keys2link = kb0010link4one.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 10B/33) OF ZAP0010ONE4XI KB0010LINK4ONE - KEY2LINK: ", key2link)                                    # 1, 2, 3
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4one[key2link]                                                                                 # {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}
                keys2check = kb2check.keys()                                                                                        #  '0x0y19z'
                for key2check in keys2check: 
                                                                                                       #  '0x0y19z'
                    # -------------------------------------------------------------------------------------------
                    # PREVIOUS LINK
                    # -------------------------------------------------------------------------------------------                                                                                                                                             
                    if kb2check [key2check] [1] == 1:                                                                               # 1 = the first node
                        # ---------------------------------------------------------------------------------------
                        # FIRST NODE - UNRESOLVED-PREVIOUS FOR THE MAIN TO SOLVE FROM PREVIOUS LAYER LAST 
                        # ---------------------------------------------------------------------------------------
                        kb0010one2put [key2check] [key2sense] [key2previous] = previous2link                                        # '-0x-0y-0z' i.e. unresolved-previous for the main to solve from previous layer last 
                        if ack2debug is True:
                            print("\n (Step 10C/33) OF ZAP0010ONE4XI - PREVIOUS SET TO: ", previous2link, "  FOR THE FIRST NODE: ", key2check)
                                                                                                                                    # PREVIOUS SET TO:  -0x-0y-0z   FOR THE FIRST NODE:  0x0y19z
                    else:
                        # ---------------------------------------------------------------------------------------
                        # PREVIOUS TO OTHERS
                        # ---------------------------------------------------------------------------------------                 
                        order2previous = kb2check [key2check] [1] - 1                                                               # previous to 3. '0x0y59z' = 2. '0x0y39z' 
                        if ack2debug is True:
                            print("\n (Step 10D/33) OF ZAP0010ONE4XI ORDER OF PREVIOUS TO HUNT: ", order2previous, "  FOR NODE: ", key2check)
                                                                                                                                    # ORDER OF PREVIOUS TO HUNT:  2   FOR NODE:  0x0y59z
                                                                                                                                    # ORDER OF PREVIOUS TO HUNT:  1   FOR NODE:  0x0y39z
                        keys2hunt1 = kb0010link4one.keys()                                  
                        for key2hunt1 in keys2hunt1:                                                                                # '0x0y19z'; '0x0y59z'; '0x0y39z'
                            # -----------------------------------------------------------------------------------
                            # HUNT PREVIOUS
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt1 = kb0010link4one[key2hunt1]                                                              # {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}    
                            keys2check4hunt1 = kb2check4hunt1.keys()                                                                #  '0x0y19z'
                            for key2check4hunt1 in keys2check4hunt1:
                                if kb2check4hunt1 [key2check4hunt1] [1] == order2previous:                                          # order of '0x0y19z' = 1 <=> previous one! 
                                    kb0010one2put [key2check] [key2sense] [key2previous] = key2check4hunt1                          # previous of '0x0y59z' = '0x0y19z'
                                    if ack2debug is True:
                                        print("\n (Step 10E/33) OF ZAP0010ONE4XI - PREVIOUS SET TO: ", key2check4hunt1, "  FOR NODE: ", key2check)
                                                                                                                                    # PREVIOUS SET TO: 0x0y39z   FOR NODE:  0x0y59z
                                                                                                                                    # PREVIOUS SET TO: 0x0y19z   FOR NODE:  0x0y39z
                            else:
                                pass

            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # input link list:
        # KB0010LINK4ONE[ 1 ]:  {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}
        # KB0010LINK4ONE[ 2 ]:  {'0x0y59z': {1: 3, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 70}}
        # KB0010LINK4ONE[ 3 ]:  {'0x0y39z': {1: 2, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 69}}
        #     key2home        = 14
        #     key2previous    = 15 <-- FOCUS!
        #     key2next        = 16
        #     key2last        = 17
        #     key2first       = 18                                                
        if ack2debug is True:    
            print("\n (Step 10B/33) OF ZAP0010ONE4XI - UPDATED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
            print("\n (Step 10C/33) OF ZAP0010ONE4XI - KB0010ONE2PUT: ", kb0010one2put)
            # {'0x0y19z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y19z', 5: '#9BA2A2', 6: 68, 7: 1, 8: Decimal('19.0'), 9: Decimal('9'), 10: 1, 11: '{started; reason-object4xi-started: function reason_object4xi at 0x02A5F660; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '-0x-0y-0z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y59z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y59z', 5: '#9BA2A2', 6: 70, 7: 1, 8: Decimal('59.0'), 9: Decimal('49'), 10: 1, 11: "{returning; kb4xi-returning-by-reason-object4xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '0x0y39z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y39z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y39z', 5: '#9BA2A2', 6: 69, 7: 1, 8: Decimal('39.0'), 9: Decimal('29'), 10: 1, 11: '{passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '0x0y19z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}}
 
            
    except:        
        print("\n (Step 10Z2/33) OF ZAP0010ONE4XI *** FAILED TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
        if ack2dragontrace is True:
            message2print = "{(Step 10Z/33) failed" + "; kb0010one2put-failed-by-zap0010one4xi: " + str(kb0010one2put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
    # -------------------------------------------------------------------------------------------------
    # (Step 11/33) THE THIRD WALKTROUGH TO EMBED NEXT LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 11A/33) OF ZAP0010ONE4XI - TRYING TO EMBED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
    try:
        # input link list:    
        # KB0010LINK4ONE[ 1 ]:  {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}
        # KB0010LINK4ONE[ 2 ]:  {'0x0y59z': {1: 3, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 70}}
        # KB0010LINK4ONE[ 3 ]:  {'0x0y39z': {1: 2, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 69}}
        keys2link = kb0010link4one.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 11B/33) OF ZAP0010ONE4XI KB0010LINK4ONE - KEY2LINK: ", key2link)                                    # 1, 2, 3
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4one[key2link]                                                                                 # {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}
                keys2check = kb2check.keys()                                                                                        #  '0x0y19z'

                for key2check in keys2check:                 
                    # -------------------------------------------------------------------------------------------
                    # NEXT LINK
                    # -------------------------------------------------------------------------------------------                                 
                    if kb2check [key2check] [1] == max2last:
                        # ---------------------------------------------------------------------------------------
                        # LAST NODE - UNRESOLVED-NEXT FOR THE MAIN TO SOLVE FROM NEXT LAYER FIRST
                        # --------------------------------------------------------------------------------------- 
                        kb0010one2put [key2check] [key2sense] [key2next] = next2link                                                # '+0x+0y+0z' i.e. unresolved-next for the main to solve from next layer first
                        if ack2debug is True:
                            print("\n (Step 11F/33) OF ZAP0010ONE4XI - NEXT SET TO: ", next2link, "  FOR LAST NODE: ", key2check)
                                                                                                                                    # NEXT SET TO:  +0x+0y+0z   FOR LAST NODE:  0x0y59z                         
                    else:
                        # ---------------------------------------------------------------------------------------
                        # NEXT TO OTHERS
                        # ---------------------------------------------------------------------------------------                     
                        order2next = kb2check [key2check] [1] + 1                                                                   # order2next of '0x0y39z' = 3
                        if ack2debug is True:
                            print("\n (Step 11E/33) OF ZAP0010ONE4XI ORDER OF NEXT TO HUNT: ", order2next, "  FOR NODE: ", key2check)
                                                                                                                                    # NEXT SET TO:  0x0y39z   FOR NODE:  0x0y19z
                                                                                                                                    # NEXT SET TO:  0x0y59z   FOR NODE:  0x0y39z                        
                        keys2hunt2 = kb0010link4one.keys()                         
                        for key2hunt2 in keys2hunt2:
                            # -----------------------------------------------------------------------------------
                            # HUNT NEXT
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt2 = kb0010link4one[key2hunt2] 
                            keys2check4hunt2 = kb2check4hunt2.keys()
                            for key2check4hunt2 in keys2check4hunt2: 
                                if kb2check4hunt2 [key2check4hunt2] [1] == order2next:                                                
                                    kb0010one2put [key2check] [key2sense] [key2next] = key2check4hunt2                          # next of '0x0y39z' is '0x0y59z' 
                                    if ack2debug is True:
                                        print("\n (Step 11G/33) OF ZAP0010ONE4XI - NEXT SET TO: ", key2check4hunt2, "  FOR NODE: ", key2check)
                                                                                                                                    #            
                                else:
                                    pass
            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # input link list:
        # KB0010LINK4ONE[ 1 ]:  {'0x0y19z': {1: 1, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 68}}
        # KB0010LINK4ONE[ 2 ]:  {'0x0y59z': {1: 3, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 70}}
        # KB0010LINK4ONE[ 3 ]:  {'0x0y39z': {1: 2, 2: '0x0y0z', 3: '0x0y0z', 4: '0x0y0z', 5: '0x0y0z', 6: '0x0y0z', 7: 69}}
        #     key2home        = 14
        #     key2previous    = 15
        #     key2next        = 16 <-- FOCUS!
        #     key2last        = 17
        #     key2first       = 18                                                    
        if ack2debug is True:    
            print("\n (Step 11B/33) OF ZAP0010ONE4XI - UPDATED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
            print("\n (Step 11C/33) OF ZAP0010ONE4XI - KB0010ONE2PUT: ", kb0010one2put)
            # {'0x0y19z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y19z', 5: '#9BA2A2', 6: 68, 7: 1, 8: Decimal('19.0'), 9: Decimal('9'), 10: 1, 11: '{started; reason-object4xi-started: function reason_object4xi at 0x02A5F660; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '-0x-0y-0z', 16: '0x0y39z',   17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y59z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y59z', 5: '#9BA2A2', 6: 70, 7: 1, 8: Decimal('59.0'), 9: Decimal('49'), 10: 1, 11: "{returning; kb4xi-returning-by-reason-object4xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '0x0y39z',   16: '+0x+0y+0z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y39z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y39z', 5: '#9BA2A2', 6: 69, 7: 1, 8: Decimal('39.0'), 9: Decimal('29'), 10: 1, 11: '{passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '0x0y19z', 16: '0x0y59z', 17: '0x0y59z', 18: '0x0y19z'}, '8xi': {}, '4xi': {}}}
            
    except:        
        print("\n (Step 10Z2/33) OF ZAP0010ONE4XI *** FAILED TO EMBED NEXT AND PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION ONE")
        if ack2dragontrace is True:
            message2print = "{(Step 10Z2/33) failed" + "; kb0010one2put-failed-by-zap0010one4xi: " + str(kb0010one2put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) PUT KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------                   
    try:
        queue0010one.put(kb0010one2put)
        ack0010put4one = True  
        if ack2debug is True:                                                                                                       # <queue4xi.Queue4Xi object at 0x05079070>
            print("\n (Step 21A/33) OF ZAP0010ONE4XI - SUCCEEDED TO PUT LAYER 0010 TO QUEUE: ", queue0010one, " KB2PUT: ", kb0010one2put)
            # {'0x0y19z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y19z', 5: '#9BA2A2', 6: 68, 7: 1, 8: Decimal('19.0'), 9: Decimal('9'), 10: 1, 11: '{started; reason-object4xi-started: function reason_object4xi at 0x02A5F660; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '-0x-0y-0z', 16: '0x0y39z', 17: '0x0y59z', 18: '0x0y19z', 19: 'reason_object4xi.py'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y59z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y59z', 5: '#9BA2A2', 6: 70, 7: 1, 8: Decimal('59.0'), 9: Decimal('49'), 10: 1, 11: "{returning; kb4xi-returning-by-reason-object4xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '0x0y39z', 16: '+0x+0y+0z', 17: '0x0y59z', 18: '0x0y19z', 19: 'reason_object4xi.py'}, '8xi': {}, '4xi': {}}, 
            #  '0x0y39z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y39z', 5: '#9BA2A2', 6: 69, 7: 1, 8: Decimal('39.0'), 9: Decimal('29'), 10: 1, 11: '{passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1, 
            #                     14: '-0x-0y-0z', 15: '0x0y19z', 16: '0x0y59z', 17: '0x0y59z', 18: '0x0y19z', 19: 'reason_object4xi.py'}, '8xi': {}, '4xi': {}}}
       
        # minimize trace after module test:
        if ack2dragontrace is True:
            message2print = "{(Step 21B/33) put" + "; kb0010one2put-put-by-zap0010one4xi: " + str(kb0010one2put)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                          # {'0x0y19z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966,
                    
    except:                                                                                                                
        print("\n (Step 21C/33) OF ZAP0010ONE4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010ONE: ", queue0010one, " KB2PUT: ", kb0010one2put)                                                                                                          #  
        if ack2dragontrace is True:
            message2print = "{(Step 21C/33) failed" + "; queue0010one-put-failed-by-zap0010one4xi: " + str(queue0010one.put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
    # -------------------------------------------------------------------------------------------------
    # (Step 20/33) MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------   
    if ack2debug is True:
        print("\n (Step 20A/33) OF ZAP0010ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL0010ONE: ", publisher_channel0010one)
                                                                                                                                    # 
    if ack0010put4one is True:
        message2send4one = "<ack0010put4one4xi>layer0010one</ack0010put4one4xi>"
    else:
        message2send4one = "<nack0010put4one4xi>layer0010one</nack0010put4one4xi>" 
    if ack2dragontrace is True:
        message2print = "{(Step 20B/33) set" + "; message2send4one-set-by-zap0010one4xi to: " + str(message2send4one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                              # <ack0010put4one4xi>layer0010one</ack0010put4one4xi>          
                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) SEND MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------                        
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel0010one.send(message2send4one)
        if ack2debug is True:     
            print("(Step 21A/33) OF ZAP0010ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel0010one, " - TIME: ", time4xi()) 
                                                                                                                                    # <ack0010put4one4xi>layer0010one</ack0010put4one4xi
        if ack2dragontrace is True:
            message2print = "{(Step 21B/33) sent" + "; message2send4one-sent-by-zap0010one4xi: " + str(message2send4one)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                          # <ack0010put4one4xi>layer0010one</ack0010put4one4xi>      
    except:
        print("(Step 21C/33) OF ZAP0010ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel0010one, " - TIME: ", time4xi()) 
        if ack2dragontrace is True:
            message2print = "{(Step 21C/33) failed" + "; message2send4one-failed-by-zap0010one4xi: " + str(message2send4one) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                          # 
         
    # -------------------------------------------------------------------------------------------------
    # (Step 22/33) RETURN QUEUE OF LAYER 0010 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:        
        print("\n (Step 22A/33) OF ZAP0010ONE4XI - RETURNING QUEUE OBJECT QUEUE0010ONE: ", queue0010one, " - TIME: ", time4xi()) 
         
    if ack2dragontrace is True:
        message2print = "{(Step 22B/33) returning" + "; queue0010one-returning-by-zap0010one4xi: " + str(queue0010one) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                              # <queue4xi.Queue4Xi object at 0x0513A2B0>    
        
    return queue0010one    
        
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   zap2actor4xi.py
#   test_zap2actor4xi.py
#   test_zap2actor4xi.txt
#   sense-test-zap2actor4xi.xml
#   reason-test-zap2actor4xi.xml
#   ace-test-zap2actor4xi4xi.xml
#   scope-sense*4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zap0010one4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>
